// This is the default configuration file for funcLib, it fills in any undefined settings to their default value.


// Global behaviour modifiers.
#ifndef FL_INCLUDE_ALL_H
#define FL_INCLUDE_ALL_H 1
#endif
#ifndef FL_INCLUDE_ALL_C
#define FL_INCLUDE_ALL_C 1
#endif
#ifndef FL_PREFIX
#define FL_PREFIX 0
#endif
#ifndef FL_PREFIX_BOTH
#define FL_PREFIX_BOTH 1
#endif
#ifndef FL_VSHMODE
#define FL_VSHMODE 0
#endif
#ifndef FL_KERNELMODE
#define FL_KERNELMODE 0
#endif



// Core Modules
#ifndef FL_CALLBACKS
#define FL_CALLBACKS 1
#endif
#ifndef FL_CALLBACKS_EXIT
#define FL_CALLBACKS_EXIT 1
#endif
#ifndef FL_CALLBACKS_POWER
#define FL_CALLBACKS_POWER 0
#endif

#ifndef FL_DEBUG
#define FL_DEBUG 1
#endif
#ifndef FL_DEBUG_TIMESTAMP
#define FL_DEBUG_TIMESTAMP 1
#endif
#ifndef FL_DEBUG_DATEFORMAT_AMERICAN
#define FL_DEBUG_DATEFORMAT_AMERICAN 0
#endif
#ifndef FL_DEBUG_CALLEDFROM
#define FL_DEBUG_CALLEDFROM 1
#endif
#ifndef FL_DEBUG_LOGGING
#define FL_DEBUG_LOGGING 1
#endif
#ifndef FL_DEBUG_LOGCLEAR
#define FL_DEBUG_LOGCLEAR 1
#endif
#ifndef FL_DEBUG_LOGPATH
#define FL_DEBUG_LOGPATH "./flDebugLog.txt"
#endif
#ifndef FL_DEBUG_STATUS
#define FL_DEBUG_STATUS 0
#endif
#ifndef FL_DEBUG_STATUS_NOTIFY
#define FL_DEBUG_STATUS_NOTIFY 1
#endif
#ifndef FL_DEBUG_STATUS_COLOR
#define FL_DEBUG_STATUS_COLOR 0xFFFF0000
#endif
#ifndef FL_DEBUG_SCREENSHOTPATH
#define FL_DEBUG_SCREENSHOTPATH "./flDebugPic%i.tga"
#endif
#ifndef FL_DEBUG_ERROR
#define FL_DEBUG_ERROR 1
#endif
#ifndef FL_DEBUG_ERROR_SHOW
#define FL_DEBUG_ERROR_SHOW 1
#endif
#ifndef FL_DEBUG_ERROR_NOTIFY
#define FL_DEBUG_ERROR_NOTIFY 1
#endif
#ifndef FL_DEBUG_ERROR_COLOR
#define FL_DEBUG_ERROR_COLOR 0xFF0000FF
#endif
#ifndef FL_DEBUG_ERROR_SCREENSHOT
#define FL_DEBUG_ERROR_SCREENSHOT 1
#endif
#ifndef FL_DEBUG_WARNING
#define FL_DEBUG_WARNING 1
#endif
#ifndef FL_DEBUG_WARNING_SHOW
#define FL_DEBUG_WARNING_SHOW 1
#endif
#ifndef FL_DEBUG_WARNING_NOTIFY
#define FL_DEBUG_WARNING_NOTIFY 1
#endif
#ifndef FL_DEBUG_WARNING_COLOR
#define FL_DEBUG_WARNING_COLOR 0xFF007FFF
#endif
#ifndef FL_DEBUG_WARNING_SCREENSHOT
#define FL_DEBUG_WARNING_SCREENSHOT 1
#endif
#ifndef FL_DEBUG_DEVWARNING
#define FL_DEBUG_DEVWARNING 1
#endif
#ifndef FL_DEBUG_DEVWARNING_SHOW
#define FL_DEBUG_DEVWARNING_SHOW 1
#endif
#ifndef FL_DEBUG_DEVWARNING_NOTIFY
#define FL_DEBUG_DEVWARNING_NOTIFY 1
#endif
#ifndef FL_DEBUG_DEVWARNING_COLOR
#define FL_DEBUG_DEVWARNING_COLOR 0xFF007FFF
#endif
#ifndef FL_DEBUG_DEVWARNING_SCREENSHOT
#define FL_DEBUG_DEVWARNING_SCREENSHOT 1
#endif
#ifndef FL_DEBUG_CRITICALERROR_SHOW
#define FL_DEBUG_CRITICALERROR_SHOW 1
#endif
#ifndef FL_DEBUG_CRITICALERROR_COLOR
#define FL_DEBUG_CRITICALERROR_COLOR 0xFF00007F
#endif
#ifndef FL_DEBUG_CRITICALERROR_SCREENSHOT
#define FL_DEBUG_CRITICALERROR_SCREENSHOT 1
#endif

#ifndef FL_MEMORY
#define FL_MEMORY 1
#endif
#ifndef FL_MEMORY
#define FL_MEMORY_ALIGNMENT_DEFAULT 16
#endif
#ifndef FL_MEMORY_SCRATCHPAD
#define FL_MEMORY_SCRATCHPAD 1
#endif
#ifndef FL_MEMORY_VMEM
#define FL_MEMORY_VMEM 1
#endif
#ifndef FL_MEMORY_POOL
#define FL_MEMORY_POOL 1
#endif
#ifndef FL_MEMORY_VMEM_BLOCKSIZE
#define FL_MEMORY_VMEM_BLOCKSIZE 512
#endif
#ifndef FL_MEMORY_VMEM_OVERFLOW
#define FL_MEMORY_VMEM_OVERFLOW 1
#endif
#ifndef FL_MEMORY_VMEM_STIDE_FILL
#define FL_MEMORY_VMEM_STIDE_FILL 1
#endif
#ifndef FL_MEMORY_VMEM_CACHE
#define FL_MEMORY_VMEM_CACHE 16384
#endif
#ifndef FL_MEMORY_PAGE
#define FL_MEMORY_PAGE 1
#endif
#ifndef FL_MEMORY_PAGE_PATH
#define FL_MEMORY_PAGE_PATH "./flPageFile.dat"
#endif
#ifndef FL_MEMORY_LOGGING
#define FL_MEMORY_LOGGING 1
#endif
#ifndef FL_MEMORY_LOGPATH
#define FL_MEMORY_LOGPATH "./flMemoryLog.txt"
#endif
#ifndef FL_MEMORY_ERRORBYTES
#define FL_MEMORY_ERRORBYTES 0
#endif

#ifndef FL_FILE
#define FL_FILE 1
#endif
#ifndef FL_FILE
#define FL_FILE_PBPPLUS 1
#endif

#ifndef FL_TIMER
#define FL_TIMER 1
#endif

#ifndef FL_INPUT
#define FL_INPUT 1
#endif

#ifndef FL_MATH
#define FL_MATH 1
#endif
#ifndef FL_MATH_VFPU
#define FL_MATH_VFPU 1
#endif
#ifndef FL_MATH_RANDTYPE
#define FL_MATH_RANDTYPE 0
#endif
#ifndef FL_MATH_RANDOMSEED
#define FL_MATH_RANDOMSEED 1
#endif
#ifndef FL_MATH_RANDOMSEED_FREQUENCY
#define FL_MATH_RANDOMSEED_FREQUENCY 4096
#endif
#ifndef FL_MATH_TRIGCACHE
#define FL_MATH_TRIGCACHE 0
#endif

#ifndef FL_STRING
#define FL_STRING 1
#endif



// Extra modules
#ifndef FL_COLOR
#define FL_COLOR 1
#endif

#ifndef FL_GRAPHICS
#define FL_GRAPHICS 1
#endif
#ifndef FL_GRAPHICS_DISP_BUFFER_VRAM
#define FL_GRAPHICS_DISP_BUFFER_VRAM 1
#endif
#ifndef FL_GRAPHICS_DISP_BUFFER_FORMAT
#define FL_GRAPHICS_DISP_BUFFER_FORMAT GU_PSM_8888
#endif
#ifndef FL_GRAPHICS_DRAW_BUFFER_FORMAT
#define FL_GRAPHICS_DRAW_BUFFER_FORMAT GU_PSM_8888
#endif
#ifndef FL_GRAPHICS_COPY_BUFFER
#define FL_GRAPHICS_COPY_BUFFER 0
#endif
#ifndef FL_GRAPHICS_VSYNC_DEFAULT
#define FL_GRAPHICS_VSYNC_DEFAULT 1
#endif
#ifndef FL_GRAPHICS_VSYNC_AUTO
#define FL_GRAPHICS_VSYNC_AUTO 1
#endif
#ifndef FL_GRAPHICS_VSYNC_AUTO_CUTOFF
#define FL_GRAPHICS_VSYNC_AUTO_CUTOFF 55.0f
#endif
#ifndef FL_GRAPHICS_DISPLAYLIST_SIZE
#define FL_GRAPHICS_DISPLAYLIST_SIZE 262144
#endif
#ifndef FL_GRAPHICS_DISPLAYLIST_STATIC
#define FL_GRAPHICS_DISPLAYLIST_STATIC 1
#endif
#ifndef FL_GRAPHICS_RENDERTARGET_STACK_SIZE
#define FL_GRAPHICS_RENDERTARGET_STACK_SIZE 8
#endif
#ifndef FL_GRAPHICS_LINES_ANTIALIAS_DEFAULT
#define FL_GRAPHICS_LINES_ANTIALIAS_DEFAULT 0
#endif
#ifndef FL_GRAPHICS_FPS_SHOW_DEFAULT
#define FL_GRAPHICS_FPS_SHOW_DEFAULT 0
#endif
#ifndef FL_GRAPHICS_FPS_SHOW_COLOR
#define FL_GRAPHICS_FPS_SHOW_COLOR 0xFFFFFFFF
#endif
#ifndef FL_GRAPHICS_FPS_DAMP
#define FL_GRAPHICS_FPS_DAMP 1
#endif
#ifndef FL_GRAPHICS_FPS_DAMPRATIO
#define FL_GRAPHICS_FPS_DAMPRATIO 0.25f
#endif
#ifndef FL_GRAPHICS_USEDEGENERATETRIS
#define FL_GRAPHICS_USEDEGENERATETRIS 0
#endif
#ifndef FL_GRAPHICS_2D
#define FL_GRAPHICS_2D 1
#endif
#ifndef FL_GRAPHICS_2D_USEDMA
#define FL_GRAPHICS_2D_USEDMA 0
#endif
#ifndef FL_GRAPHICS_2D_ELLIPSE_MINLINES
#define FL_GRAPHICS_2D_ELLIPSE_MINLINES 16
#endif
#ifndef FL_GRAPHICS_2D_ELLIPSE_EDGESPERRAD
#define FL_GRAPHICS_2D_ELLIPSE_EDGESPERRAD 0.25
#endif
#ifndef FL_GRAPHICS_3D
#define FL_GRAPHICS_3D 1
#endif
#ifndef FL_GRAPHICS_EFFECTS_FULLSCREEN
#define FL_GRAPHICS_EFFECTS_FULLSCREEN 1
#endif

#ifndef FL_CAMERA
#define FL_CAMERA 1
#endif

#ifndef FL_TEXTURE
#define FL_TEXTURE 1
#endif
#ifndef FL_TEXTURE_UNCACHED
#define FL_TEXTURE_UNCACHED 0
#endif
#ifndef FL_TEXTURE_AUTOMIPMAP
#define FL_TEXTURE_AUTOMIPMAP 8
#endif
#ifndef FL_TEXTURE_AUTOMIPMAP_PALETTED
#define FL_TEXTURE_AUTOMIPMAP_PALETTED 0
#endif
#ifndef FL_TEXTURE_AUTOSWIZZLE
#define FL_TEXTURE_AUTOSWIZZLE 1
#endif
#ifndef FL_TEXTURE_ERRORTEX
#define FL_TEXTURE_ERRORTEX 0
#endif
#ifndef FL_TEXTURE_ERRORTEX_COMPILE
#define FL_TEXTURE_ERRORTEX_COMPILE 0
#endif
#ifndef FL_TEXTURE_ERRORTEX_PATH
#define FL_TEXTURE_ERRORTEX_PATH "./flTexError.tga"
#endif
#ifndef FL_TEXTURE_PRESERVENONALPHA
#define FL_TEXTURE_PRESERVENONALPHA 1
#endif
#ifndef FL_TEXTURE_PCX
#define FL_TEXTURE_PCX 1
#endif
#ifndef FL_TEXTURE_TGA
#define FL_TEXTURE_TGA 1
#endif
#ifndef FL_TEXTURE_BMP
#define FL_TEXTURE_BMP 1
#endif
#ifndef FL_TEXTURE_WAL
#define FL_TEXTURE_WAL 0
#endif
#ifndef FL_TEXTURE_PNG
#define FL_TEXTURE_PNG 0
#endif
#ifndef FL_TEXTURE_RAW
#define FL_TEXTURE_RAW 1
#endif
#ifndef FL_TEXTURE_MANIPULATION
#define FL_TEXTURE_MANIPULATION 1
#endif

#ifndef FL_MODEL
#define FL_MODEL 1
#endif
#ifndef FL_MODEL_OBJ
#define FL_MODEL_OBJ 1
#endif
#ifndef FL_MODEL_MD2
#define FL_MODEL_MD2 1
#endif

#ifndef FL_SPRITE
#define FL_SPRITE 1
#endif

#ifndef FL_FONT
#define FL_FONT 1
#endif
#ifndef FL_FONT_HSPACE_DEFAULT
#define FL_FONT_HSPACE_DEFAULT 0
#endif
#ifndef FL_FONT_VSPACE_DEFAULT
#define FL_FONT_VSPACE_DEFAULT 0
#endif
#ifndef FL_FONT_COLOR_DEFAULT
#define FL_FONT_COLOR_DEFAULT 0xFFFFFFFF
#endif
#ifndef FL_FONT_TABWIDTH_DEFAULT
#define FL_FONT_TABWIDTH_DEFAULT 5
#endif

#ifndef FL_COLLISION
#define FL_COLLISION 1
#endif

#ifndef FL_NOTIFY
#define FL_NOTIFY 1
#endif
#ifndef FL_NOTIFY_FREQUENCY
#define FL_NOTIFY_FREQUENCY 120
#endif
#ifndef FL_NOTIFY_DURATION
#define FL_NOTIFY_DURATION 3.0f
#endif
#ifndef FL_NOTIFY_VOLUME
#define FL_NOTIFY_VOLUME 0
#endif
#ifndef FL_NOTIFY_BATTERY
#define FL_NOTIFY_BATTERY 1
#endif
#ifndef FL_NOTIFY_TIME
#define FL_NOTIFY_TIME 1
#endif
#ifndef FL_NOTIFY_TRAYSIZE
#define FL_NOTIFY_TRAYSIZE 4
#endif

#ifndef FL_UMD
#define FL_UMD 0
#endif

#ifndef FL_FILEBROWSER
#define FL_FILEBROWSER 0
#endif




// Simple graphics system
/*#ifndef FL_GRAPHICS_SIMPLE
#define FL_GRAPHICS_SIMPLE 0
#endif
#ifndef FL_GRAPHICS_SIMPLE_CLIPPING
#define FL_GRAPHICS_SIMPLE_CLIPPING 1
#endif
#ifndef FL_GRAPHICS_SIMPLE_IMAGESTACK
#define FL_GRAPHICS_SIMPLE_IMAGESTACK 0
#endif
#ifndef FL_GRAPHICS_SIMPLE_SPRITE
#define FL_GRAPHICS_SIMPLE_SPRITE 1
#endif
#ifndef FL_GRAPHICS_SIMPLE_SPRITE_ALPHA_COLOR
#define FL_GRAPHICS_SIMPLE_SPRITE_ALPHA_COLOR 0xFFFF00FF
#endif
#ifndef FL_GRAPHICS_SIMPLE_FONT
#define FL_GRAPHICS_SIMPLE_FONT 1
#endif
#ifndef FL_GRAPHICS_SIMPLE_FONT_DEFAULTCOLOR
#define FL_GRAPHICS_SIMPLE_FONT_DEFAULTCOLOR 0xFF000000
#endif
#ifndef FL_GRAPHICS_SIMPLE_FONT_ALPHA_COLOR
#define FL_GRAPHICS_SIMPLE_FONT_ALPHA_COLOR 0xFFFF00FF
#endif
#ifndef FL_GRAPHICS_SIMPLE_FONT_ALPHA_UPPER_COLOR
#define FL_GRAPHICS_SIMPLE_FONT_ALPHA_UPPER_COLOR 0xFF0000FF
#endif
#ifndef FL_GRAPHICS_SIMPLE_FONT_ALPHA_LOWER_COLOR
#define FL_GRAPHICS_SIMPLE_FONT_ALPHA_LOWER_COLOR 0xFF00FF00
#endif*/

